import QtQuick 2.0
import MuseScore 3.0


MuseScore {

    function setCursorToTime(cursor, time){
        cursor.rewind(0);
        while (cursor.segment) { 
            var current_time = cursor.tick;
            if(current_time>=time){
                return true;
            }
            cursor.next();
        }
        cursor.rewind(0);
        return false;
    }// end setcursor To Time
	
    onRun: {

    var tpc2note = ["cbb","gbb","dbb","abb","ebb","bbb","fb","cb","gb","db","ab","eb","bb","f","c","g","d","a","e","b","f#","c#","g#","d#","a#","e#","b#","f##","c##","g##","d##","a##","e##","b##"];
    var cursor = curScore.newCursor();
    
    // melnotes
	// O: notename
	// 1: pitch
    // 2: tpc
    var melnotes = new Array(2048); 
	for(var i=0; i<2048; i++) melnotes[i]=new Array();
	var mcount = 0;
        
    cursor.rewind(0); // beginning of score
    cursor.staffIdx = 0;
    //console.log("curScore.selection = ", curScore.selection)
    
    
    if (curScore.selection != null){
        var selection = curScore.selection;
        var el = selection.elements;
        var notes = [];
        var n = 0;
        for (var i = 0; i < el.length; i++) {
            var element = el[i];
            if (element.type == Element.NOTE) {
                notes[n] = element;
                console.log ("melnote ", tpc2note[notes[n].tpc]);
                melnotes[mcount][0] = tpc2note[notes[n].tpc];
                
                melnotes[mcount][1] = notes[n].pitch;
                melnotes[mcount][2] = notes[n].tpc;
                mcount++;
                n++;
            }
        }
    
    }
    // no selection notes foudn: assume full score
    if (mcount == 0){
        cursor.rewind(0); // beginning of score
        console.log("no selection")
        while (cursor.segment) {
        
            if (cursor.element && cursor.element.type === Element.CHORD) {
                var notes = cursor.element.notes;
                var name;
                // collect top note only
                
                var i = notes.length -1;
                melnotes[mcount][0] = tpc2note[notes[i].tpc];
                
                melnotes[mcount][1] = notes[i].pitch;
                melnotes[mcount][2] = notes[i].tpc;
                mcount++;
            }// end if CHORD 
            cursor.next();
            
        } // end while segment
    } // end fullscore
    
    

    curScore.startCmd();
    cmd("next-score");
    curScore.endCmd();

    var cursor = curScore.newCursor()
    if (typeof curScore === 'undefined') {
        console.log ("All done");
        Qt.quit();
    }
    
    cursor.rewind(0); // beginning of score
    
    cursor.staffIdx = 0;
    for (var c = 0; c < mcount; c++) {
        var cur_time=cursor.tick;
        // 320 for 1/8 notes
        cursor.setDuration(320, 1920);
        cursor.addNote(melnotes[c][1]); //add 1st note
        //addnote moves the cursor to the next segment
        var next_time=cursor.tick;
        //rewind to this note
        setCursorToTime(cursor, cur_time); 
		var note = cursor.element.notes[0];
        // now set the tpc
		note.tpc = melnotes[c][2];
        //move the cursor forward to where it was
        setCursorToTime(cursor, next_time);
    }        

	Qt.quit();
	}// end on Run
}
